SYD-AES(1)

# NAME

syd-aes - AES-CTR Encryption and Decryption Utility

# SYNOPSIS

*syd-aes* _[-hv]_ _-e|-d_ _-k <hex-encoded key>_ _-i <hex-encoded iv>_

# DESCRIPTION

The *syd-aes* utility uses the Linux Kernel Cryptography API to encrypt
and decrypt data using AES-CTR mode. It supports both encryption and
decryption operations, with the key and IV provided as hexadecimal
strings. Given data from standard input, *syd-aes* performs the
specified operation and outputs the result to standard output.
*syd-aes* uses pipes and _splice_(2) to transfer data using zero-copy,
and therefore able to encrypt/decrypt files of arbitrary size.

# OPTIONS

|[ *-h*
:< Display help.
|[ *-v*
:< Enable verbose mode. If standard error is a terminal, it prints progress
   updates periodically, similar to *dd*(1).
|[ *-e*
:< Encrypt the input data.
|[ *-d*
:< Decrypt the input data.
|[ *-k <key>*
:< Hex-encoded key (256 bits for AES-CTR).
|[ *-i <iv>*
:< Hex-encoded IV (128 bits for AES-CTR).

# SEE ALSO

_syd_(1), _syd_(2), _syd_(5), _splice_(2), _syd-key_(1), _syd-nul_(1)

*syd* homepage: https://sydbox.exherbolinux.org/

# AUTHORS

Maintained by Ali Polatel. Up-to-date sources can be found at
https://gitlab.exherbo.org/sydbox/sydbox.git and bugs/patches can be
submitted to https://gitlab.exherbo.org/groups/sydbox/-/issues. Discuss
in #sydbox on Libera Chat.
