SYD-CP(1)

# NAME

syd-cp - Utility to copy files using _splice_(2)

# SYNOPSIS

*syd-cp* _-[hapfv]_ _<src-file>_ _<dst-file-or-directory>_

*syd-cp* _-[hfv]_ _<dst-file>_

# DESCRIPTION

The *syd-cp* utility uses _splice_(2) system call to copy files from
source to destination. It reads data from the source file and writes it
to the destination file, using zero-copy to transfer data efficiently.
The utility can preserve file permissions and provides verbose output
detailing the copy progress if requested. Given only a destination file,
the utility reads from standard input and saves to the destination.

Note, this utility assumes the file descriptor to the destination file
refers to a pipe which is the case when the respective path is marked
for encryption for Syd's Crypt Sandboxing. This utility provides the
user an efficient way to encrypt files under Syd. As such, using
this utility to copy files outside Syd or files not marked for
encryption will fail with the error "EINVAL" indicating the destination
file is not a pipe.

# OPTIONS

|[ *-h*
:< Display help.
|[ *-f*
:< Force overwriting the destination file. By default, it exits with error
   if the destination file already exists.
|[ *-p*, *-a*
:< Preserve file permissions.
|[ *-v*
:< Enable verbose mode. If standard error is a terminal, it prints progress
   updates periodically, similar to *dd*(1).

# SEE ALSO

_syd_(1), _syd_(2), _syd_(5)

*syd* homepage: https://sydbox.exherbolinux.org/

# AUTHORS

Maintained by Ali Polatel. Up-to-date sources can be found at
https://gitlab.exherbo.org/sydbox/sydbox.git and bugs/patches can be
submitted to https://gitlab.exherbo.org/groups/sydbox/-/issues. Discuss
in #sydbox on Libera Chat.
